SystemOrganization addCategory: 'OrbeonBPMRuntime_Tests'!

TestCase subclass: #BpmProcessExecutionTest
	instanceVariableNames: 'procInstance users'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 15:22'!
createFormInstance: xmlMethodName definitionNamed: definitionName app: app
	"The receiver create anOrbeonFormInstance of form definition named <definitionName> of Orbeon Applicaiton named <app> using the method <xmlMethodName> to get the XML string of the form "
	| application definition |

	application := OrbeonApplication applicationNamed: app.
	definition := application definitionNamed: definitionName.

	^(OrbeonFormInstance app: app form: definitionName id: UUID new asString)
			definition: definition;
			xmlString: (OrbeonFormTemplate perform: xmlMethodName);
			processXML;
			yourself! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 15:44'!
getProcessMatrix

	^self getProcessMatrixFor: procInstance! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 15:44'!
getProcessMatrixFor: aBpmProcessInstance

	^aBpmProcessInstance getProcessMatrix! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 15:45'!
processTask: aBpmTaskInstance withUserNamed: aString withForm: anOrbeonFormInstance

	^self processTask: aBpmTaskInstance withUserNamed: aString withForm: anOrbeonFormInstance on: procInstance! !

!BpmProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 15:46'!
processTask: aBpmTaskInstance withUserNamed: aString withForm: anOrbeonFormInstance on: aBpmProcessInstance
	| assignment |

	assignment := (self getProcessMatrixFor: aBpmProcessInstance) getAssignmentFor: aBpmTaskInstance ifNone: [self assert: false].

	(users at: aString) take: assignment.

	aBpmTaskInstance formInstance: anOrbeonFormInstance.

	(users at: aString) finalizeAssignment: assignment.! !

!BpmProcessExecutionTest methodsFor: 'Accessing' stamp: 'BrunoBB 12/06/2015 15:22'!
procInstance
	^procInstance! !

!BpmProcessExecutionTest methodsFor: 'Updating' stamp: 'BrunoBB 12/06/2015 15:22'!
procInstance: newValue
	procInstance := newValue! !

BpmProcessExecutionTest subclass: #BugTrackerProcessExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:08'!
formInstance_analyzeDeveloperReportNo

	^self createFormInstance: #form_analyzeDeveloperReportNo definitionNamed: 'analyze-developer-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:08'!
formInstance_analyzeDeveloperReportYes

	^self createFormInstance: #form_analyzeDeveloperReportYes definitionNamed: 'analyze-developer-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:48'!
formInstance_analyzeIssueNo

	^self createFormInstance: #form_analyzeIssueNo definitionNamed: 'analyze-issue' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:46'!
formInstance_analyzeIssueReportAccept

	^self createFormInstance: #form_analyzeIssueReportAccept definitionNamed: 'analyze-issue-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:47'!
formInstance_analyzeIssueReportReject

	^self createFormInstance: #form_analyzeIssueReportReject definitionNamed: 'analyze-issue-report' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:48'!
formInstance_analyzeIssueYes

	^self createFormInstance: #form_analyzeIssueYes definitionNamed: 'analyze-issue' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:44'!
formInstance_executeTestFailed

	^self createFormInstance: #form_executeTestFailed definitionNamed: 'execute-test' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:44'!
formInstance_executeTestPassed

	^self createFormInstance: #form_executeTestPassed definitionNamed: 'execute-test' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:06'!
formInstance_internalTest

	^self createFormInstance: #form_internalTest definitionNamed: 'internal-test' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:06'!
formInstance_reportFixes

	^self createFormInstance: #form_reportFixes definitionNamed: 'report-fixes' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:09'!
formInstance_reportSolution

	^self createFormInstance: #form_reportSolution definitionNamed: 'report-solution' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 13:08'!
formInstance_reportWorkaround

	^self createFormInstance: #form_reportWorkaround definitionNamed: 'report-workaround' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:43'!
formInstance_testCase

	^self createFormInstance: #form_analyzeData1 definitionNamed: 'test-case' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'forms' stamp: 'BrunoBB 11/29/2015 12:45'!
formInstance_testOk

	^self createFormInstance: #form_testOk definitionNamed: 'test-ok' app: 'ue'! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 15:24'!
setUp
	| procDefinition processGenerator |

	users := Dictionary new.

	processGenerator := BpmProcessGenerator exampleTestCaseFixIssueReportArchitect.

	procDefinition := processGenerator getProcessDefinitionNamed: 'test-case-process' ifNone: [self assert: false].

	procInstance := procDefinition createAndStartProcessInstance: nil. "the process is create by an anonynous user"

	procDefinition addProcessInstance: procInstance.

	users at: 'alberto' put: (BpmUser getUserNamed: 'alberto').! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/28/2015 19:43'!
tearDown

	procInstance definition removeProcessInstance: procInstance! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 15:55'!
testExecutionTestExecutionFailedRejectIssue
	| currentTask nextTasks gateway endArtifact |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestFailed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeIssueReportReject.
	self assert: (currentTask getDefinitionName = 'analyze-issue-report').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'accept-issue').

	endArtifact := gateway outTransitions last endArtifact.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 16:47'!
testExecutionTestExecutionOk
	| currentTask nextTasks gateway endArtifact |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestPassed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testOk.
	self assert: (currentTask getDefinitionName = 'test-ok').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 16:30'!
testExecutionTestExecutionSubProcessL1
	"Execute the subprocess only to one level (inmediate childs of the top process)"
	| currentTask nextTasks gateway endArtifact subProcess subProcessArtifact |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestFailed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeIssueReportAccept.
	self assert: (currentTask getDefinitionName = 'analyze-issue-report').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'accept-issue').

	subProcessArtifact := gateway outTransitions last endArtifact.
	subProcess := subProcessArtifact processInstance.
"------------------ Sub Process Execution Starts here -------------------------------"
	self assert:  subProcess isSubProcess.
	self assert: (subProcess startEvent getDefinitionName = 'start').

	currentTask := subProcess currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeIssueYes on: subProcess.
	self assert: (currentTask getDefinitionName = 'analyze-issue').

	gateway := (subProcess generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'can fix').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_reportFixes on: subProcess.
	self assert: (currentTask getDefinitionName = 'report-fixes').

	nextTasks := (subProcess generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_internalTest on: subProcess.
	self assert: (currentTask getDefinitionName = 'internal-test').

	endArtifact := (subProcess generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
"------------------ Sub Process Execution Ends here -------------------------------"
"------------------ Parent Process Execution Starts here -------------------------------"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestPassed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testOk.
	self assert: (currentTask getDefinitionName = 'test-ok').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

!BugTrackerProcessExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 16:41'!
testExecutionTestExecutionSubProcessL2
	"Execute the subprocess only to two level "
	| currentTask nextTasks gateway endArtifact subProcessL1 subProcessArtifactL1 subProcessL2 subProcessArtifactL2 |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestFailed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeIssueReportAccept.
	self assert: (currentTask getDefinitionName = 'analyze-issue-report').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'accept-issue').

	subProcessArtifactL1 := gateway outTransitions last endArtifact.
	subProcessL1 := subProcessArtifactL1 processInstance.
	"------------------START::L1:: Sub Process Execution -------------------------------"
		self assert:  subProcessL1 isSubProcess.
		self assert: (subProcessL1 startEvent getDefinitionName = 'start').

		currentTask := subProcessL1 currentActivities last.
		self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeIssueNo on: subProcessL1.
		self assert: (currentTask getDefinitionName = 'analyze-issue').

		gateway := (subProcessL1 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
		gateway := gateway last.
		self assert: (gateway getDefinitionName = 'can fix').

		subProcessArtifactL2 := gateway outTransitions last endArtifact.
		subProcessL2 := subProcessArtifactL2 processInstance.
		"------------------START::L2:: Sub Process Execution -------------------------------"
			self assert:  subProcessL2 isSubProcess.
			self assert: (subProcessL2 startEvent getDefinitionName = 'start').

			currentTask := subProcessL2 currentActivities last.
			self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeDeveloperReportYes on: subProcessL2.
			self assert: (currentTask getDefinitionName = 'analyze-developer-report').

			gateway := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
			gateway := gateway last.
			self assert: (gateway getDefinitionName = 'has-solution').

			currentTask := gateway outTransitions last endArtifact.
			self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_reportSolution on: subProcessL2.
			self assert: (currentTask getDefinitionName = 'report-solution').

			endArtifact := (subProcessL2 generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
			endArtifact := endArtifact last.
			self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
		"------------------END::L2:: Sub Process Execution -------------------------------"
	"------------------RESUME::L1:: Sub Process Execution -------------------------------"
		endArtifact := subProcessL1 transitions last endArtifact.
		self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).
	"------------------END::L1:: Sub Process Execution-------------------------------"
"------------------RESUME::Top:: Process Execution-------------------------------"
	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testCase.
	self assert: (currentTask getDefinitionName = 'test-case').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_executeTestPassed.
	self assert: (currentTask getDefinitionName = 'execute-test').

	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'is-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_testOk.
	self assert: (currentTask getDefinitionName = 'test-ok').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.

	self assert: ((endArtifact getDefinitionName = 'end') and: [endArtifact isEndEvent]).! !

BpmProcessExecutionTest subclass: #SmaltalksRegistrationExecutionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMRuntime_Tests'!

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:03'!
formInstance_acceptRegistration

	^self createFormInstance: #form_acceptRegistration definitionNamed: 'accept-registration' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:02'!
formInstance_analyzeData1

	^self createFormInstance: #form_analyzeData1 definitionNamed: 'analyze-data' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:02'!
formInstance_analyzeData2

	^self createFormInstance: #form_analyzeData2 definitionNamed: 'analyze-data' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 11:56'!
formInstance_registration

	^self createFormInstance: #form_registration definitionNamed: 'registration' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/19/2015 12:04'!
formInstance_securityReport

	^self createFormInstance: #form_securityReport definitionNamed: 'security-report' app: 'st'! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 16:42'!
setUp
	| procDefinition processGenerator |

	users := Dictionary new.

	processGenerator := BpmProcessGenerator exampleSmalltalksRegistration.

	procDefinition := processGenerator getProcessDefinitionNamed: 'registration' ifNone: [self assert: false].

	procInstance := procDefinition createAndStartProcessInstance: (BpmUser getUserNamed: 'alberto').

	procDefinition addProcessInstance: procInstance.

	users at: 'alberto' put: (BpmUser getUserNamed: 'alberto').! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 11/17/2015 12:01'!
tearDown

	procInstance definition removeProcessInstance: procInstance! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 16:43'!
testExecutionPathRegistrationAccepted
	| currentTask nextTasks gateway endArtifact |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_registration.
	self assert: (currentTask getDefinitionName = 'registration').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeData1.
	self assert: (currentTask getDefinitionName = 'analyze-data').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'security-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_acceptRegistration.
	self assert: (currentTask getDefinitionName = 'accept-registration').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: (endArtifact getDefinitionName = 'end 1').

	^self assert: true! !

!SmaltalksRegistrationExecutionTest methodsFor: 'other' stamp: 'BrunoBB 12/06/2015 16:45'!
testExecutionPathRegistrationRejected
	| currentTask nextTasks gateway endArtifact |

	self assert: (procInstance startEvent getDefinitionName = 'start').

	currentTask := procInstance currentActivities last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_registration.
	self assert: (currentTask getDefinitionName = 'registration').

	nextTasks := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	currentTask := nextTasks last.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_analyzeData2.
	self assert: (currentTask getDefinitionName = 'analyze-data').

	"this gateway is created and executed immediately"
	gateway := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact]. 
	gateway := gateway last.
	self assert: (gateway getDefinitionName = 'security-issue').

	currentTask := gateway outTransitions last endArtifact.
	self processTask: currentTask withUserNamed: 'alberto' withForm: self formInstance_securityReport.
	self assert: (currentTask getDefinitionName = 'security-report').

	endArtifact := (procInstance generateNextTransitionsFrom: currentTask) collect: [:each | each endArtifact].
	endArtifact := endArtifact last.
	self assert: (endArtifact getDefinitionName = 'end 2').! !
